package uk.ac.shef;


import com.zerog.ia.api.pub.*;

import java.io.*;
import java.util.*;

public class VMChecker extends CustomCodeAction {
  public void install(InstallerProxy proxy){
    //this points to the user selected VM
    String javaHome = installerProxy.substitute("$JAVA_HOME$");
    String gateHome = installerProxy.substitute("$USER_INSTALL_DIR$");
    String fileSep = System.getProperty("file.separator");
    String nl = System.getProperty("line.separator");

    if(javaHome.equals(gateHome + fileSep + "jre")){
      //using the locally installed JRE
      //nothing to check
    }else{
      //check the VM version
      String command = javaHome + fileSep + "bin" + fileSep + "java";
      String version = Utils.getVMVersion(command);
      if(version.compareTo(Utils.MIN_JDK_VER) < 0){
        //invalid VM version
        Utils.showErr("The java virtual machine at" + nl +
                      javaHome + nl +
                      "is not a supported version!" + nl +
                      "Gate requires a JDK version " + Utils.MIN_JDK_VER +
                      " or higher." + nl +
                      "You have selected version " + version + nl +
                      "Please go back and select a different JVM!");
        GUIAccess gui = (GUIAccess) proxy.getService(GUIAccess.class);
        if(gui != null){
          gui.goPrevious();
        }
        return;
      }
    }
  }

  public void uninstall(UninstallerProxy parm1)
    throws com.zerog.ia.api.pub.InstallException {
  }

  public String getUninstallStatusMessage() {
    return "";
  }
  public String getInstallStatusMessage() {
    return "Checking your VMs";
  }
}